REM PWM Tlatkov regultor s 08M2

symbol DATA_PIN = C.0	;vstup sriovch dat pro 4094
symbol CLOCK_PIN = C.1	;vstup hodinovho signlu pro 4094
symbol VYSTUP_PIN = C.2	;PWM vstup
symbol STAV = b3		;promnn pro zjiovn potu svtcch LED
symbol PLUS = pinC.4	;vstupn pin pro zvyovn otek	
symbol MINUS = pinC.3	;vstupn pin pro sniovn otek
symbol FREQ = 199		;parametr pro nastaven frekvence PWM (199 = 5 kHz)
symbol IMP = 800		;parametr pro nastaven dlky aktivnho impulsu (4 x FREQ)
symbol KROK = 100		;parametr pro zvten/zmenen aktivnho impulsu podle promnn STAV

init:		low VYSTUP_PIN			;PWM vstup nastaven na rove low
		let w0 = 0				;vynulovn parametru aktivn impuls pkazu PWMOUT
		let STAV = -1			;nastaven promnn STAV
		for b4 = 0 to 7			;sriov data 00000000 pro obvod 4094 - nulovn vstup
			low DATA_PIN
			pulsout CLOCK_PIN,1
		next b4
				
test_tlac:	if PLUS = 0 then gosub pridej	;test smknut tlatek
		if MINUS =0 then gosub uber 
		goto test_tlac
		
pridej:	pause 100							;smyka pro zvten aktivnho impulzu - pidn otek 
		if PLUS = 0 then
			let STAV = STAV + 1
			let w0 = w0 + KROK
			if w0 > IMP then let w0 = IMP end if
			if STAV < 8 then gosub rozsvit
			if STAV => 7 then let STAV = 7 end if 
			pwmout vystup_pin,FREQ,w0			;PWM vstup
		end if
		return
		
uber:		pause 100							;smyka pro zmenen aktivnho impulsu - ubrn otek
		if MINUS = 0 then
			let w0 = w0 - KROK
			if w0 > IMP then let w0 = 0 end if
			pwmout vystup_pin,FREQ,w0
			branch STAV,(zhas1,zhas2,zhas3,zhas4,zhas5,zhas6,zhas7,zhas8)
		end if
skok:		return
		
		goto test_tlac

rozsvit:	high DATA_PIN		;procedura pro rozsvcen LED
		pulsout CLOCK_PIN,1
		return

zhas1:	low DATA_PIN		;procedura zhasnut LED - podle promnn STAV
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		let STAV=STAV-1
		goto skok
	
zhas2:	low DATA_PIN
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		high DATA_PIN
		pulsout CLOCK_PIN,1
		let STAV=STAV-1
		goto skok

zhas3:	low DATA_PIN
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		high DATA_PIN
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		let STAV=STAV-1
		goto skok

zhas4:	low DATA_PIN
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		high DATA_PIN
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		let STAV=STAV-1
		goto skok

zhas5:	low DATA_PIN
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		high DATA_PIN
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		let STAV=STAV-1
		goto skok
		
zhas6:	low DATA_PIN
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		high DATA_PIN
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		let STAV=STAV-1
		goto skok

zhas7:	low DATA_PIN
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		high DATA_PIN
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		let STAV=STAV-1
		goto skok

zhas8:	low DATA_PIN
		pulsout CLOCK_PIN,1
		high DATA_PIN
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		pulsout CLOCK_PIN,1
		let STAV=STAV-1
		goto skok
	
		end
		